/*
 * SPDX-FileCopyrightText: 2006-2021 Istituto Italiano di Tecnologia (IIT)
 * SPDX-License-Identifier: BSD-3-Clause
 */

// Autogenerated by Thrift Compiler (0.14.1-yarped)
//
// This is an automatically generated file.
// It could get re-generated if the ALLOW_IDL_GENERATION flag is on.

#ifndef YARP_THRIFT_GENERATOR_STRUCT_MAP2DPATHDATA_H
#define YARP_THRIFT_GENERATOR_STRUCT_MAP2DPATHDATA_H

#include <yarp/dev/api.h>

#include <yarp/os/Wire.h>
#include <yarp/os/idl/WireTypes.h>
#include <yarp/dev/Map2DLocation.h>

namespace yarp::dev {

class YARP_dev_API Map2DPathData :
        public yarp::os::idl::WirePortable
{
public:
    // Fields
    /**
     * list of waypoints which define the path
     */
    std::vector<yarp::dev::Nav2D::Map2DLocation> waypoints{};
    /**
     * user defined string
     */
    std::string description{};

    // Default constructor
    Map2DPathData() = default;

    // Constructor with field values
    Map2DPathData(const std::vector<yarp::dev::Nav2D::Map2DLocation>& waypoints,
                  const std::string& description);

    // Read structure on a Wire
    bool read(yarp::os::idl::WireReader& reader) override;

    // Read structure on a Connection
    bool read(yarp::os::ConnectionReader& connection) override;

    // Write structure on a Wire
    bool write(const yarp::os::idl::WireWriter& writer) const override;

    // Write structure on a Connection
    bool write(yarp::os::ConnectionWriter& connection) const override;

    // Convert to a printable string
    std::string toString() const;

    // If you want to serialize this class without nesting, use this helper
    typedef yarp::os::idl::Unwrapped<Map2DPathData> unwrapped;

    class Editor :
            public yarp::os::Wire,
            public yarp::os::PortWriter
    {
    public:
        // Editor: default constructor
        Editor();

        // Editor: constructor with base class
        Editor(Map2DPathData& obj);

        // Editor: destructor
        ~Editor() override;

        // Editor: Deleted constructors and operator=
        Editor(const Editor& rhs) = delete;
        Editor(Editor&& rhs) = delete;
        Editor& operator=(const Editor& rhs) = delete;
        Editor& operator=(Editor&& rhs) = delete;

        // Editor: edit
        bool edit(Map2DPathData& obj, bool dirty = true);

        // Editor: validity check
        bool isValid() const;

        // Editor: state
        Map2DPathData& state();

        // Editor: start editing
        void start_editing();

#ifndef YARP_NO_DEPRECATED // Since YARP 3.2
        YARP_DEPRECATED_MSG("Use start_editing() instead")
        void begin()
        {
            start_editing();
        }
#endif // YARP_NO_DEPRECATED

        // Editor: stop editing
        void stop_editing();

#ifndef YARP_NO_DEPRECATED // Since YARP 3.2
        YARP_DEPRECATED_MSG("Use stop_editing() instead")
        void end()
        {
            stop_editing();
        }
#endif // YARP_NO_DEPRECATED

        // Editor: waypoints field
        void set_waypoints(const std::vector<yarp::dev::Nav2D::Map2DLocation>& waypoints);
        void set_waypoints(size_t index, const yarp::dev::Nav2D::Map2DLocation& elem);
        const std::vector<yarp::dev::Nav2D::Map2DLocation>& get_waypoints() const;
        virtual bool will_set_waypoints();
        virtual bool did_set_waypoints();

        // Editor: description field
        void set_description(const std::string& description);
        const std::string& get_description() const;
        virtual bool will_set_description();
        virtual bool did_set_description();

        // Editor: clean
        void clean();

        // Editor: read
        bool read(yarp::os::ConnectionReader& connection) override;

        // Editor: write
        bool write(yarp::os::ConnectionWriter& connection) const override;

    private:
        // Editor: state
        Map2DPathData* obj;
        bool obj_owned;
        int group;

        // Editor: dirty variables
        bool is_dirty;
        bool is_dirty_waypoints;
        bool is_dirty_description;
        int dirty_count;

        // Editor: send if possible
        void communicate();

        // Editor: mark dirty overall
        void mark_dirty();

        // Editor: mark dirty single fields
        void mark_dirty_waypoints();
        void mark_dirty_description();

        // Editor: dirty_flags
        void dirty_flags(bool flag);
    };

private:
    // read/write waypoints field
    bool read_waypoints(yarp::os::idl::WireReader& reader);
    bool write_waypoints(const yarp::os::idl::WireWriter& writer) const;
    bool nested_read_waypoints(yarp::os::idl::WireReader& reader);
    bool nested_write_waypoints(const yarp::os::idl::WireWriter& writer) const;

    // read/write description field
    bool read_description(yarp::os::idl::WireReader& reader);
    bool write_description(const yarp::os::idl::WireWriter& writer) const;
    bool nested_read_description(yarp::os::idl::WireReader& reader);
    bool nested_write_description(const yarp::os::idl::WireWriter& writer) const;
};

} // namespace yarp::dev

#endif // YARP_THRIFT_GENERATOR_STRUCT_MAP2DPATHDATA_H
